* =====================================================
DEFINE CLASS atfSets as awSets of awPublic.prg && Ajout par Assistant d'Adaptation FoxInCloud version 2.26 (mode source) le 07/03/2018 14:58
* =====================================================

&& Cette classe est l'implmentation standard du code de rglage de l'environnement de l'application.
&& FoxInCloud RECOMMANDE l'utilisation d'une classe car sa mthode .Destroy() rtablit
&& l'environnement de dveloppement, donc respecte les rglages de chaque dveloppeur.
&& Si vous prfrez une implmentation procdurale, vous en trouverez des explications et exemples plus loin.

&& Pour dmarrer votre serveur FoxInCloud de test, tapez dans votre fentre de commandes :

* do <path to>atfTest

* ---------------------
PROCEDURE Init
lparameters ;
  result; && @ rsultat du dmarrage de l'application - mentionn dans .../foxincloud-status.xxx, et dans le log du serveur si !m.success
, toAppHost as awAppHost of awAppHost.fxp && Objet Hte d'application (mode Web seulement)

* m.toAppHost vous donne accs  :
* - toute prorit PROTECTED ajoute  votre classe de serveur - voir la classe atfServer dans atfServer.prg
* - l'objet configuration de votre application dans m.toAppHost.oConfigApp - voir la classe atfAppConfig dans atfServer.prg
* - de nombreuses autres proprits et mthodes que vous pouvez dcouvrir en plaant un point d'arrt et en tapant 'm.toAppHost.' pour dclencher l'intellisense

* CONSEIL : Vous pouvez utiliser les proprits et mthodes suivantes dans votre code :
#if .F. && documentation
this.wlWeb && l'application fonctionne en mode Web
this.wlLAN && (this.wlLAN = !this.wlWeb) l'application fonctionne en mode LAN (desktop)
this.lDevMode && l'application fonctionne dans l'IDE de VFP
this.lAutomation && L'application fonctionne en mode COM (si this.wlWeb)
#endif

local success as Boolean

success = DoDefault(@m.result) && IMPORTANT ! rgle le proprits ci-dessus
if !m.success
  return .f.
endif

* ATTENTION
* --------------------------------------------------------------------------------------------
* L'Assistant d'Adaptation FoxInCoud a rcupr le code ci-dessous dans
* 'c:\atoutfox\atfdemo\progs\atfdemo.prg'.
* Il s'agit d'un canevas comportant les principaux lments de configuration de l'application.
* Il doit probablement tre retouch pour fonctionner parfaitement en mode web,
* notamment ajuster les chemins et les tests spcifiques au mode LAN.
* Note: la fonction awPublic.prg!wlWeb() indique si l'application fonctionne en mode Web.
* --------------------------------------------------------------------------------------------
* Si vous faites une nouvelle installation aprs une modification manuelle,
* l'Assistant d'Adaption le dtectera et vous proposera de vrifier
* le fichier avant un ventuel remplacement.
* --------------------------------------------------------------------------------------------


* Si une erreur srieuse survient pendant l'initialisation de cette classe, rglez :
* success = .F.
* result = [raison(s) pour la(es)quelle(s) l'environnement n'a pu tre rgl et/ou l'application ne peut dmarrer dans de bonnes conditions]
* En mode Web, cette erreur sera crite dans le log de l'application et envoye par email  l'administrateur du site;
* En mode LAN, vous pouvez faire quelque chose de similaire

* Quand ce code s'excute, le serveur FoxInCloud a rgl le rpertoire par dfaut CurDir()
* sur le dossier racine de l'application, o se trouve le projet
* (C:\ATOUTFOX\ATFDEMO\)
* Les chemins suivants sont donc relatifs  ce dossier 

SET PATH TO ".\DATA\;.\PROGS\;.\PROGS\BITMAPS\;.\PROGS\FORMS\;.\PROGS\LIBS\" ADDITIVE


IF !InList(_VFP.StartMode, 2, 3, 5) && En mode automation COM, Visual FoxPro fait un SET PROCEDURE et SET CLASSLIB implicite sur tous les fichiers contenus dans l'exe ou la dll - si vous rexcutez ces instructions par la suite, les performances de votre serveur d'automation COM se dgraderont fortement.

  SET PROCEDURE TO atfdemo,atfinit,utile ADDITIVE

  ClassLibAdd("gwsav.vcx,atf.vcx") && modify command abDev
  EXTERNAL PROCEDURE ClassLibAdd

ENDIF


&& Ajout par Assistant d'Adaptation FoxInCloud version 2.26 (mode source) le 07/03/2018 14:27
*-FIC-  (see above) SET PATH TO (Home(1) + 'Tools\' + 'AB\') ADDITIVE
*-FIC-  (see above) AB() && loads FoxInCloud public modules located in the above folder, and shared on GitHub: https://github.com/FoxInCloud/FoxInCloud-AB.git
*-FIC-  (see above) SET CLASSLIB TO (Addbs(JustPath(Sys(16))) + 'LIBS\ATF.VCX') ADDITIVE && atf.vcx derives from aw.vcx
&& Ajout par Assistant d'Adaptation FoxInCloud version 2.26 (mode source) le 07/03/2018 14:27

&& /!\ make sure all SET PATH/LIBRary/CLASslib/PROCedure
&& executed after this line have the ADDITIVE clause

* Lancement application
*-FIC-  (see above) SET PATH TO (ADDBS(JUSTPATH(SYS(16)))) ADDITIVE
IF atfInit() && Initialisation de l'environnement
	ON ERROR
	WITH _SCREEN
		.CAPTION = "LANCEMENT DE ATFDEMO"
		.ICON = "ecor.ico" && Icone de l'application
		._version = 'B1.0'
		._title = "ATFDEMO " + ._DEBUG
	ENDWITH
	MODIFY WINDOW SCREEN TITLE _SCREEN._title
	* Effacement de l'cran
	CLEAR
	WITH _SCREEN
		* Affichage de la fentre  taille normale
		.WINDOWSTATE = 2
		.CAPTION = ._title
	ENDWITH
	* Prparation sortie Windows
	ON SHUTDOWN CLEAR EVENTS
	* Suppression du menu
	SET SYSMENU OFF
	=maj_titre_fenetre()
	* Lancement du formulaire
ENDIF
return m.success && l'application ne dmarre pas si .F.
endproc

* ---------------------
PROCEDURE Destroy

* ajoutez ici [ou dplacez de this.init()]
* les instructions que vous devez excuter quand l'application se dcharge,
* telle que le nettoyage des objets et/ou RemoveProperty(_Screen, ...)

return DoDefault()
* Vous n'avez pas besoin de restaurer Set("Path"), Set("Procedure") et Set("Classlib")
* car DoDefault() le fait automatiquement. 
endproc

* =====================================================
ENDDEFINE && CLASS atfSets && Ajout par Assistant d'Adaptation FoxInCloud version 2.26 (mode source) le 07/03/2018 14:58
* =====================================================























&& Ceci est un exemple de programme qui rgle l'environnement de l'application
&& Idalement les versions LAN (desktop) et WEB de votre application PARTAGENT ce module
&& Vous pouvez utiliser une de ces trois implmentations (voir proprits dans atfServer.prg) :

&& Implmentation              .cAppSetsLib    .cAppSets     .lAppSetsClass
&& ---------------------       -------------   ----------    ---------------
&& 1-Instancier 'atfSets'      'atfSets.prg'   'atfSets'     .T.
&& 2-Excuter ce programme     'atfSets.prg'   ''            .F.
&& 3-Excuter 'atfSets()'      'atfSets.prg'   'atfSets'     .F.

&& Notes :
&& - En mode Web, par analogie avec le mode LAN, quand ce module s'excute,
&& Curdir() est le dossier du programme principal o se trouve le projet : '..\' dans ce cas
&& - FoxInCloud excute l'application dans une classe session ;
&& Les SETs dpendant de la session de donnes n'ont pas besoin d'tre restaurs

#IF .F. && dplacez ou supprimez cette ligne si vous voulez adapter ce code

&& EXEMPLE D'IMPLEMENTATION n 1 (RECOMMENDE): instancier un classe 'atfSets'
* ===================================================
&& Dans cette implmentation this.Destroy() restaure l'environnement initial (utile en dveloppement)
* ===================================================
DEFINE CLASS atfSets as awSets of awPublic.prg

* ---------------------
PROCEDURE Init
lparameters ;
  result; && @ rsultat du dmarrage de l'application - mentionn dans .../foxincloud-status.atf
, toAppHost as awAppHost of awAppHost.fxp && Objet Hte d'application Web
	
* m.toAppHost vous donne accs  :
* - toute prorit PROTECTED ajoute  votre classe de serveur > modify command atfServer.prg - class atfServer
* - l'objet configuration de votre application dans m.toAppHost.oConfigApp > modify command atfServer.prg - class atfAppConfig
* - de nombreuses autres proprits et mthodes que vous pouvez dcouvrir en plaant un point d'arrt et en tapant 'm.toAppHost.' pour dclencher l'intellisense

* CONSEIL
* Votre code peut utiliser les proprits et mthodes suivantes :
#if .F.
this.wlWeb && = !this.wlLAN && l'application fonctionne en mode Web
this.wlLAN && = !this.wlWeb && l'application fonctionne en mode LAN (desktop)
this.lDevMode && l'application fonctionne en mode dveloppement
this.Set(<setting>, <value> [, 1,2,...]) && ralise un SET et le rtablit dans this.Destroy() - voir abDev.prg!abSet
#endIf

local success as Boolean
success = DoDefault(@m.result) && rgle this.wlWeb, this.wlLAN, this.lDevMode, this.oConfigApp (par atfTest|Prod.ini)
if m.success

	&&  ce stade, curdir() est le dossier du programme principal, vous pouvez ajouter les dossiers enfant au path facilement
	SET PATH TO 'progs,forms,reports,images,data' ADDITIVE && ADDITIVE ne pas oublier
	
	if !this.lAutomation && in automation mode, VFP automatically SETs PROCEDURE and CLASSLIB to any file included - reSETting to these files can cause a runtime error
		SET PROCEDURE TO myStuff1, myStuff2 ADDITIVE && ADDITIVE ne pas oublier
		SET CLASSLIB TO myClasses ADDITIVE && ADDITIVE ne pas oublier
	endIf
	
	SET DELETED OFF
	SET SAFETY OFF
	SET DATE AMERICAN
	
	if m.this.wlLAN
		SET TALK OFF
	endIf
	
	OPEN DATABASE myDatabase
	
	wMenu('set sysmenu to') && supprime le menu systme
	do myMenu.mpr && installe le menu de l'application 
	
endif



* Si une erreur srieuse survient pendant l'initialisation de cette classe, rglez :
* success = .F.
* result = [raison(s) pour la(es)quelle(s) l'environnement n'a pu tre rgl et/ou l'application ne peut dmarrer dans de bonnes conditions]
* En mode Web, cette erreur sera crite dans le log de l'application et envoye par email  l'administrateur du site;
* En mode LAN, vous pouvez faire quelque chose de similaire

return m.success
endProc

* ---------------------
PROCEDURE Destroy

* restaurez ici les lments d'environnement qui ne sont pas pris en charge automatiquement
endProc

* ---------------------
hidden procedure Init_dataSession_for_child_forms_launched_at_startup
lparameters ;
  result as String; && @ erreur ventuelle
, toAppHost as awAppHost of awAppHost.fxp; && Objet Hte d'application

* exemple de mthode

if Empty(m.toAppHost.uFormsLaunchAtStartup)
	return
endIf

local success as Boolean

success = .T.

open database atf

if lInList('myForm1.scx', m.toAppHost.uFormsLaunchAtStartup)
	success = this.use('view1;view2;table1,Alias1') and m.success
endIf

if lInList('myForm2.scx', m.toAppHost.uFormsLaunchAtStartup)
	success = this.use('view2;view3;table2') and m.success
endIf

return m.success
endProc

* ---------------------
hidden procedure use
lparameters ;
  result as String; && @ erreur ventuelle
, aliases; && Aliases  ouvrir

* exemple de mthode

local success as Boolean;
, aView[1] as String;
, nView as Integer;
, aTable[1] as String;
, cTable as String;
, cAlias as String;
, cNoData as String;
, oException as Exception;

nView = ADBObjects(aView, "VIEW")

success = .T.

if ALines(m.aTable, m.aliases, 5, ';') > 0
	for each cTable in m.aTable
		
		try
			cAlias = Evl(GetWordNum(m.cTable, 2, ','), JustStem(m.cTable))
			cTable = JustStem(GetWordNum(m.cTable, 1, ','))
			if !Used(m.cAlias)
				cNoData = Iif(Ascan(m.aView, m.cTable, 1, -1, 1, 7) > 0, 'NODATA', '')
				use (m.cTable) alias (m.cAlias) in 0 again shared &cNoData
			endIf

			do case
			case Lower(m.cTable) == Lower('countryCodes')
				&& cette vue ncessite de vraies donnes ; par ex. vue sur les codes pays alimentant des listes
				local parm1, parm2
				parm1 = someValue
				parm2 = otherValue
				Requery(m.cAlias)
			endCase
		catch to oException
			success = cResultAdd(@m.result, cException(m.oException)) && cResultAdd(), cException(): modify command abDev
		endtry
	endFor
endIf

return m.success
endProc

ENDDEFINE && CLASS atfSets






&& SAMPLE IMPLEMENTATION # 2: execute 'atfSets.prg'
* ---------------------------------------------------
SET PATH TO 'progs,forms,reports,images,data' ADDITIVE && ADDITIVE ne pas oublier

if !wlAutomation()
	SET PROCEDURE TO myStuff1, myStuff2 ADDITIVE && ADDITIVE ne pas oublier
	SET CLASSLIB TO myClasses ADDITIVE && ADDITIVE ne pas oublier
endIf

SET DELETED OFF
SET SAFETY OFF
SET DATE AMERICAN

OPEN DATABASE myDatabase

&& ...

&& SAMPLE IMPLEMENTATION # 3: execute 'atfSets' procedure
* ---------------------------------------------------
PROCEDURE atfSets

SET PATH TO 'progs,forms,reports,images,data' ADDITIVE && ADDITIVE ne pas oublier

if !wlAutomation()
	SET PROCEDURE TO myStuff1, myStuff2 ADDITIVE && ADDITIVE ne pas oublier
	SET CLASSLIB TO myClasses ADDITIVE && ADDITIVE ne pas oublier
endIf

SET DELETED OFF
SET SAFETY OFF
SET DATE AMERICAN

OPEN DATABASE myDatabase

&& ...

endProc


#endIf  && dplacez cela si vous voulez adapter ce code
