&& L'tape 3 (Publier) de l'Assistant d'Adaptation FoxInCloud (FAA) a cr ce programme

#IF FILE('aw.h')
	#include aw.h && in <Home(1)>\tools\ab\aw\ utilisateurs avec licence
#ELSE
	#include ab.h && in <Home(1)>\tools\ab\ tous les utilisateurs
#ENDIF

* ===========================================
DEFINE CLASS atfServer AS awServer OF awServer.prg
	&& atfServer est votre classe de Serveur d'Application FoxInCloud (FAS)
	&& L'Assistant d'Adaptation FoxInCloud (FAA) cre 2 sous-classes OLEPUBLIC :
	&& - atfServerTest pour votre serveur de test,
	&& - atfServerProd pour votre serveur de production.
	&& Nous vous recommandons d'installer ces 2 serveur sur votre serveur de production physique ;
	&& ils permettront  vos clients et vous de tester les volutions de l'application avant leur mise en production.
	&& Comme ces 2 versions partagent le mme code, vous pouvez dvelopper sur l'une ou l'autre.
	* ===========================================

	&& {zz} note interne:  partir d'ici, awServer est le document matre

	&& Pour ajouter des proprits statiques  votre serveur,
	&& assurez-vous de les dclarer PROTECTED pour conserver la signature de votre objet COM (sinon vous devrez le r-enregistrer sur votre serveur de production).
	#IF .F.
	PROTECTED yourServerProperty
	yourServerProperty = someValue
	#ENDIF

	&& toutes les proprits PROTECTED de atfServer sont automatiquement ajoutes comme proprits PUBLIC  votre classe hte d'application (atfAppHost as awAppHost of awAppHost.fxp)
	&& vous pourrez donc y accder :
	#IF .F.

		&& - depuis votre objet atfProcess ou atfAjax par :
		THIS.oAppHost.yourServerProperty

		&& - depuis votre code d'application par:
		LOCAL oAppHost
		IF wlAppHost(@m.oAppHost)
			m.oAppHost.yourServerProperty = someValue
		ENDIF

	#ENDIF

* ===========================================
* ===========================================

cawServerIni = ''
&& OBLIGATOIRE
&& Fichier .ini pour awServerConfig; doit tre dans le mme dossier que le projet
&&  dfinir dans vos sous-classes atfServerTest|Prod
&& valeurs typiques : atfTest.ini / atfProd.ini

&& ------------------------------------------------
&& Les 3 rglages qui suivent permettent de dfinir le module de code
&& qui rgle l'environnement de votre application
&& Ce code peut tre une classe dans un .prg ou un .vcx, une procdure dans un .prg ou un .prg
&& Idalement ce code est partag avec la version LAN pour assurer un environnement d'excution exactement identique
&& Ce module peut faire tous les SETs ncessaires sans limitation
&& FoxInCloud rectifiera le cas chant les SET incompatibles
&& ------------------------------------------------

cAppSetsLib = 'atfSets.prg' && atfSets.prg
&& OBLIGATOIRE
&& Chemin du .prg ou .vcx o se trouve la procdure ou classe d'environnement de l'application

cAppSets = 'atfSets' && atfSets
&& Nom de la classe ou procdure d'environnement (SETs) de l'application situe dans <this.cAppSetsLib>
&& Si vide, <this.cAppSetsLib> est excute

lAppSetsClass = .T. && .T.
&& this.cAppSets est une classe dfinie dans <this.cAppSetsLib>.prg

&& ------------------------------------------------
&& Ici vous allez dcider comment gnrer les pages HTML des formulaires de haut niveau (top level); vous pouvez :
&& - soit les gnrer avec une sous-classe de 'awProcess' COMME INDIQU DANS L'EXEMPLE CI-APRS
&& - soit les produire avec ASP, ASPX, PHP, etc. en incluant  votre page le code HTML produit par FoxInCloud (directive server-side include)
&& ------------------------------------------------

cawProcessClass = 'atfProcess' && atfProcess AS awProcess OF awServer.prg
&& OBLIGATOIRE
&& Classe Process FoxInCloud
&& Sous-classez si vous voulez construire les pages HTML avec wConnect
&& Cette solution est prfrable car elle permet d'instancier les formulaires dynamiquement et de leur passer des paramtres
&& Pour construire une page standard d'un formulaire, utilisez la mthode <votre sous-class d'awProcess>::wFormStandardPage(<formulaire>[, <paramtre1>[, <paramtre2>[, ...]]])

cawAppConfigClass = 'atfAppConfig' && atfAppConfig AS awAppConfig OF awServer.prg
&& Classe de configuration de l'application FoxInCloud
&& Sous-classez si vous avez besoin d'autres paramtres configurables en ligne

uFormsLaunchAtStartup = ''
&& crans de premier niveau  instancier au dmarrage du serveur, .T. pour tout lancer, vide pour ne rien lancer
&& Renseignez cette proprit si vous utilisez ASP, ASPX, PHP, ou autre pour construire vos pages HTML, au lieu d'une sous-classe de 'awProcess' (this.cawProcessClass)
&& Si vous utilisez une sous-classe de 'awProcess' (recommand), cette dclaration est inutile car vous pouvez instancier les formulaires dynamiquement avec une mthode tutoProcess::wForm*()
&& En cours de dveloppement, dclarer le formulaire sur lequel on est en train de travailler fait gagner du temps sur les tests.
&& Liste spare par des virgules : *.scx, class, *.vcx
&& > *.vcx : toutes les classes Form contenues dans le .vcx sont instancies; dans ce cas awAppConfig::cPrgPath est REQUIS

&& ------------------------------------------------
&& Utilisateur spciaux pour l'application
&& ------------------------------------------------

wUserAnonymous = 0
&& Identifiant d'utilisateur signifiant 'utilisateur anonyme' pour votre application
&& En gnral, c'est une valeur de la cl primaire des utilisateurs qui n'existe pas
&& Par exemple, si la cl primaire des utilisateurs est un entier, ce peut tre 0 ou .NULL.

wUserDemo = .NULL.
&& Identifiant de l'utilisateur de dmo (pour votre application)
&& L'utilisateur de dmo peut avoir plusieurs sessions ouvertes simultanment
&& Si isNull(), aucun utilisateur de dmo n'existe.

wlUserTemp = .F.
&& Votre application gre l'emprunt d'identit

* ===========================================
* ===========================================

&& Les proprits ci-aprs ont, par dfaut, les valeurs hrites de awServer

&& ------------------------------------------------
&& Utilisation de jQuery pour les scripts client
&& ------------------------------------------------

ljQueryAdd = .T.
&& Ajouter les scripts et CSS jQuery aux pages HTML
&& /!\ attention, FoxInCloud.js entrera bientt en migration de Prototype.js vers jQuery.js, dans une prochaine version le script jQuery sera charg systmatiquement et cette option sera sans effet
&& 2016-09-21 -- {FiC V 2.22.0-beta.7} dprci - jQuery est dsormais requis

ljQueryUIadd = .T.
&& Ajouter les scripts et CSS jQuery UI aux pages HTML /!\ attention, FoxInCloud.js entrera bientt en migration de Scriptaculous.js vers jQueryUI.js, dans une prochaine version le script jQueryUI sera charg systmatiquement et cette option deviendra sans effet

cjQueryUItheme = 'base' && 'base', 'black-tie', 'blitzer', 'cupertino', 'dark-hive', 'dot-luv', 'eggplant', 'excite-bike', 'flick', 'hot-sneaks', 'humanity', 'le-frog', 'mint-choc', 'overcast', 'pepper-grinder', 'redmond', 'smoothness', 'south-street', 'start', 'sunny', 'swanky-purse', 'trontastic', 'ui-darkness', 'ui-lightness', 'vader'
&& {en		http://jqueryui.com/themeroller/ demonstrates these standard themes and allows you,
&& Thme jQuery UI ; doit correspondre  un nom de dossier dans awScripts/jQuery-ui-*/themes
&& Vous pouvez aussi le dfinir dans le fichier de configuration de votre application atfTest|Prod.ini
&& http://jqueryui.com/themeroller/ dmontre l'effet de ces diffrents thmes standard
&& et vous permet, le cas chant, de crer votre propre thme

ljQueryUIdialog = .T.
&& En mode 'classique', utilisez un dialogue jQueryUI plutt qu'une fentre 'Prototype Window Class'
&& /!\ En version 3.x, Prototype Window Class sera dprcie aussi assurez-vous d'adapter vos ventuelles CSS spcifiques  temps.

&& ------------------------------------------------
&& Gnration HTML Bootstrap
&& http://getbootstrap.com/
&& 2016-11-30 -- {FiC V 2.23.0}
&& ------------------------------------------------

lBootstrapAdd = .F. && 2016-11-30 thn -- {FiC V 2.23.0}
&& Ajouter les scripts et CSS Bootstrap  la page HTML
&& force this.ljQueryAdd = .T.
&& Rgler globalement avec la proprit .BSlHTMLgen ci-dessous, ou au niveau de chaque formulaire par form.wBSlHTMLgen = .T.

lFontAwesomeAdd = .F. && 2016-11-30 thn -- {FiC V 2.23.0}
&& Ajouter la CSS 'Font Awesome'  la page HTML

lBStreeViewAdd = .F. && 2017-09-26 thn -- {FiC V 2.25.0-beta.9}
&& Ajouter les JS et CSS 'Bootstrap TreeView'  la page HTML

BSlHTMLgen = .NULL. && 2017-08-22 thn -- {FiC V 2.25.0-beta.8}
&& Gnrer le HTML des formulaires compatible Bootstrap (auto-adaptatif) : .T. - tous, .F. - aucun, .null. - selon Form.wBSlHTMLgen

lPrototypeAdd = .T.
&& charger Prototype.js (http://prototypejs.org/) et les scripts qui en dpendent: Scriptaculous, PrototypeWindowClass, event.simulate, etc.
&& si .F. et !this.BSlHTMLgen, this.ljQueryUIdialog forc  .T.
&& merci de tester votre application avec .F. ds que possible car le dfaut va passer bientt  .F.
&& remplacez les appels  $() par jQuery() dans vos mthodes d'vnements et .wcHTMLgen(), et dans atf.js

&& ------------------------------------------------
&& Sous-classes du chassis FoxInCloud
&& ------------------------------------------------

cawAppHostClass = 'awAppHost' && atfAppHost AS awAppHost OF awAppHost.fxp
&& Classe hte de l'application FoxInCloud
&& Sous-classez awAppHost si vous voulez implmenter une de ces mthodes crochets :
&& .Init_App_Ante() : avant que l'application soit initialise
&& .Init_App_Post() : aprs que l'application est initialise
&& .Destroy_App_Ante(): avant que l'application soit dcharge
&& .Destroy_App_Post(): aprs que l'application est dcharge

cawHTMLGenClass = 'awHTMLgen' && atfHTMLgen AS awHTMLgen OF awHTML.fxp
&& Classe de gnration de HTML FoxInCloud
&& sous-classez awHTMLgen si vous avez des besoins de gnration HTML que vous ne pouvez traiter avec les mthodes .wcHTMLgen() des objets

cawAJAXClass = 'awAJAX' && atfAJAX AS awAJAX OF awServer.fxp
&& Classe AJAX FoxInCloud
&& Sous-classez awAJAX si vous avez des requtes AJAX particulires
&& Dans ce cas, vous pourrez aussi avoir besoin d'ajouter des mthodes et/ou des handlers d'vnement  FoxInCloud.js

cawSessionClass = 'awSession' && atfSession AS awSession OF awServer.fxp
&& Classe Session (sous-classe de 'awSession')
&& Sous-classez awSession si vous souhaitez ajouter des champs ou des indexes  la table de Session standard 'wwSession'

cawProcessSetsClass = 'awProcessSets' && atfProcessSets AS awProcessSets OF awServer.fxp
&& Classe d'environnement (SETs) des REQUTES (process)
&& Sous-classez awProcessSets si vos requtes 'conventionnelles' ncessitent des SETs particuliers

cDataSyncClass = 'acDataSyncVFP' && as acDataSyncVFP of acData.prg
&& Classe de synchronisation ascendante des donnes
&& Sous-classez acDataSyncVFP si vous souhaitez y ajouter des fonctionnalits

cFrmIBclass = 'atfFrmIB' && as awFrmIB of aw.vcx
&& Classe de l'cran pour 'InputBox()'

cFrmLogErrorClass = 'atfFrmLogError' && as awFrmLogError of aw.vcx
&& Classe de l'cran d'analyse des erreurs de l'application

cFrmMBclass = 'atfFrmMB' && as awFrmMB of aw.vcx
&& Classe de l'cran pour 'MessageBox()'

cScriptMapExts = 'php,pl,vfp,zip'
&& Extensions de requte routes vers this.cawProcessClass
&& Ces extensions doivent tre 'mappes' dans le serveur Web sur ...\bin\wc.dll

&& --------------------------------------------------------------------------------------------------------------------------------------
&& Rglages de la sauvegarde automatique, pour chaque utilisateur, ds variables PUBLIC, de _Screen.proprits et _VFP.proprits
&& --------------------------------------------------------------------------------------------------------------------------------------

lAppUserEnvSave = .T.
&& sauver et restaurer l'environnement de l'application  chaque action de l'utilisateur
&& (.F. est le rglage par dfaut pour rtro-compatibilit)
&& si votre application n'utilise aucun lment global dpendant de l'utilisateur :
&& - aucun menu(s)
&& - aucune barre(s) d'outils
&& - aucune variable PUBLIC, _Screen.proprit ou _VFP.proprit o votre application stocke des informations dpendantes des actions de l'utilisateur
&& ou vous ne stockez dans des variable PUBLIC, _Screen.proprit ou _VFP.proprit que des donnes dfinies une fois pour toutes au lancement de l'application, jamais modifies par les actions de l'utilisateur, telles que des rglages partags  l'identique par tous les utilisateurs,
&& vous pouvez rgler atfServer.lAppUserEnvSave = .F.
&& sinon, vous devez conserver atfServer.lAppUserEnvSave = .T.
&& voir aussi atfProcess.lAppUserEnvSave() qui permet d'optimiser la sauvegardes/restauration des donnes d'environnement applicatif selon l'utilisateur et/ou la requte


&& Les rglages suivants s'appliquent  this.lAppUserEnvSave = .T.

lPublicVariablesAllAtStartup = .T.
&& Toutes les variables PUBLIC sont cres au lancement de l'application ?
&& = .T. (optimis) : toutes les variables PUBLIC tant cres au lancement de l'application, inutile de les vrifier  chaque requte
&& = .F. (dconseill) :  chaque requte, vrifier que la variable est PUBLIC, la dclarer si inexistante
&& Pour utiliser .T., assurez vous que toutes les dclarations PUBLIC sont dans le programme d'initialisation de l'application (atfSets.prg)
&& Pour ce faire, vous pouvez simplement les dplacer ou copier toutes dans atfSets.prg!atfSets.init()

cPublicVariablesObjectSave = ''
&& Variables PUBLIC de type objet que vous voulez sauvegarder pour chaque utilisateur, dlimits par ',', insensible  la casse
&& = vide ou .null. : aucune variable PUBLIC de type objet n'est sauvegarde
&& = chane non vide : sauvegarder les variables PUBLIC indiques si elles existent et sont de type objet
&& Vous devez indiquer des noms exacts ; les masques ne sont pas supports
&& Si la classe de l'objet est drive d'une classe FoxInCloud aw.vcx!aw*, assurez-vous de bien remplir .wcPropSave (et/ou .wcPropSaveNot)
&& Les variables PUBLIC des autres types (y compris tableau) sont sauvegardes automatiquement

_ScreenPropertiesSave = .NULL.
&& Nom(s) et/ou masque(s) des _Screen.Properties que vous voulez sauvegarder, dlimits par ',', insensible  la casse
&& = .null.  : sauvegarder toutes les proprits ajoutes  _Screen
&& = '' ou .F. : ne sauvegarder aucune proprit ajoutes  _Screen
&& Indiquez ici les proprits ajoutes  _screen dont la valeur change selon les actions de l'utilisateur et doivent donc tre sauvegarde
&& Vous pouvez combiner des noms exacts et des masques (ex. 'zzz*' pour sauver toutes les proprits dont le nom commence par 'zzz')
&& Vous pouvez ajouter des proprits  _Screen par addProperty(_Screen, 'maProprit', maValeur) ou _Screen.addProperty('maProprit', maValeur)
&& Les proprits ajoutes dynamiquement (au fil des actions de l'utilisateur) sont supportes
&& Note: les objets ajouts  _Screen par _Screen.AddObject() ne sont pas supports pour l'instant && si vous avez besoin de ce support, merci d'en faire part  support@foxincloud.com
&& Si vous utilisez de nombreuses _Screen.Properties, ce rglage optimisera le temps de rponse des requtes

_ScreenPropertiesSaveNot = '_clePkUser'
&& Nom / masque des _Screen.Properties que vous ne voulez pas sauvegarder, dlimits par ',', insensible  la casse
&& = vide ou .null. : sauvegarder toutes les proprits dfinies par this._ScreenPropertiesSave
&& = non vide : sauvegarder les proprits dfinies par this._ScreenPropertiesSave sauf celles rpondant aux noms et masques indiqus
&& Listez ici les proprits de _screen qui sont rgles une fois pour toutes au dmarrage de l'application et sont indpendantes des actions de l'utilisateur
&& Vous pouvez combiner des noms exacts et des masques (ex. 'zzz*' pour ne pas sauvegarder les proprits dont le nom commence par 'zzz')
&& Vous pouvez ajouter des proprits  _Screen par addProperty(_Screen, 'maProprit', maValeur) ou _Screen.addProperty('maProprit', maValeur)
&& Si de nombreuses _Screen.Properties que vous utilisez sont statiques (indpendantes de l'utilisateur), ce rglage optimisera le temps de rponse des requtes.

_VFPpropertiesSave = .NULL.
&& Nom(s) et/ou masque(s) des _VFP.Properties que vous voulez sauvegarder, dlimits par ',', insensible  la casse
&& = .null.  : sauvegarder toutes les proprits ajoutes  _VFP, sauf les tableaux qui ne sont pas supports
&& = '' ou .F. : ne sauvegarder aucune proprit ajoutes  _VFP
&& Indiquez ici les proprits ajoutes  _VFP dont la valeur change selon les actions de l'utilisateur et doivent donc tre sauvegarde
&& Vous pouvez combiner des noms exacts et des masques (ex. 'zzz*' pour sauver toutes les proprits dont le nom commence par 'zzz')
&& Vous pouvez ajouter des proprits  _VFP par addProperty(_VFP, 'maProprit', maValeur) ou _VFP.addProperty('maProprit', maValeur)
&& Les proprits ajoutes dynamiquement (au fil des actions de l'utilisateur) sont supportes
&& Les tableaux ne sont PAS supports
&& Si vous utilisez de nombreuses _VFP.Properties, ce rglage optimisera le temps de rponse des requtes

_VFPpropertiesSaveNot = ''
&& Nom / masque des _VFP.Properties que vous ne voulez pas sauvegarder, dlimits par ',', insensible  la casse
&& = vide ou .null. : sauvegarder toutes les proprits dfinies par this._VFPpropertiesSave
&& = non vide : sauvegarder les proprits dfinies par this._VFPpropertiesSave sauf celles rpondant aux noms et masques indiqus
&& Listez ici les proprits de _VFP qui sont rgles une fois pour toutes au dmarrage de l'application et sont indpendantes des actions de l'utilisateur
&& Vous pouvez combiner des noms exacts et des masques (ex. 'zzz*' pour ne pas sauvegarder les proprits dont le nom commence par 'zzz')
&& Vous pouvez ajouter des proprits  _VFP par addProperty(_VFP, 'maProprit', maValeur) ou _VFP.addProperty('maProprit', maValeur)
&& Si de nombreuses _VFP.Properties que vous utilisez sont statiques (indpendantes de l'utilisateur), ce rglage optimisera le temps de rponse des requtes.

lFormVariableCreate = .F.
&& stocker une rfrence  chaque formulaire(.scx) dans une variable publique nomme comme la variable que DO FORM cre par dfaut

&& ------------------------------------------------
&& Rglages divers
&& ------------------------------------------------

lHTML5placeHolder = .T.
&& dfinir <input placeholder="" /> selon Textbox.ToolTipText | Editbox.ToolTipText | Combobox.ToolTipText

lHTML5type = .T.
&& dfinir <input type="" /> selon le type de donnes de la Textbox

cLangUser = '' && [cLangUser()]
&& Langue prfre du dveloppeur (cLangUser() par dfaut)

nMemoryMB = 256 && Between(m.this.nMemoryMB, 64, 512)
&& Limite de mmoire utilise en mga octets

nCASmax = 0 && 2017-12-05 -- {FiC V 2.26.0-beta.5}
&& > 0 : Nombre maximum de CAS que vous allouez  cette application
&& <= 0 : Le nombre maximum de CAS est celui autoris par les pack de licenses Serveur et CAS
&& remplace ce que this.oConfig.oawApp.nCASmax dfinit

&& ------------------------------------------------
&& Voir aussi les rglages dans la classe de configuration de l'application 'atfAppConfig as awAppConfig of awServer.prg'
&& ------------------------------------------------

* ===========================================
ENDDEFINE && CLASS atfServer
* ===========================================

* ===========================================
DEFINE CLASS atfAppConfig AS awAppConfig OF awServer.prg
	* ===========================================

	&& Ajoutez ici toute proprit que vous devez pouvoir modifier en ligne par cette URL de test :
	&& - http://localhost/atfTest/bin/wc.dll?wwMaint~EditConfig && dveloppement
	&& - http://yourDomain/bin/wc.dll?wwMaint~EditConfig && production
	&& par exemple,
	#IF .F.
		cMyProperty = '' && toujours utiliser un prfixe de type, 'c' dans ce cas pour caractre
	#ENDIF
	&& Pour plus d'information  propos de l'objet de configuration de l'application :
	&& - modify command awServer.prg (utilisateur avec licence FoxInCloud)
	&& - http://www.west-wind.com/webconnection/docs/_s8103hqw9.htm

	* ===========================================
ENDDEFINE && CLASS atfAppConfig
* ===========================================

* ===========================================
DEFINE CLASS atfProcess AS awProcess OF awServer.prg
	* ===========================================

	* ==============================================================
	* == 1 == 1 == 1 == 1 == 1 == 1 == 1 == 1 == 1 == 1 == 1 == 1 ==
	* ==============================================================

	&& IDENTIFICATION DE L'UTILISATEUR POUR VOTRE APPLICATION
	&& ------------------------------------------------------
	&& Implmenter si votre application gre l'identification et/ou les droits utilisateur globalement,
	&& par exemple stocke l'identifiant et/ou les droits de l'utilisateur dans une variable publique ou une proprit de _Screen.
	&& Si votre application gre l'identification et/ou les droits utilisateur au niveau de chaque formulaire,
	&& implmenter les mthodes wUserSet() et wUserGet() de votre sous-classe de aw.vcx!awFrm.

	* ------------------------------------------------------------
	PROTECTED PROCEDURE wUserSet && Rgle l'utilisateur courant
		&& excut avant chaque requte sur l'application
		LPARAMETERS ;
			twUser,; && Identifiant utilisateur pour l'application (=this.wUserAnonymous si anonyme)
		tlTemp && [.F.] Cet identifiant est emprunt (voir awServer.wlUserTemp)

		*!*	#IF .F. && DEBUT D'EXEMPLE DE CODE

		*!*		_Screen.AddProperty('myUserID', m.twUser) && si {} !atfServer.lAppUserEnvSave or empty(atfServer._ScreenPropertiesSave)
		*!*		_Screen.AddProperty('myUserRights', myUserRights(m.twUser))

		*!*		DO myUserPublicVariablesSetProcedure(m.twUser)

		*!*	#ENDIF  && FIN D'EXEMPLE DE CODE
		_SCREEN.ADDPROPERTY('_clepkUser', m.twUser)
		RETURN DODEFAULT(m.twUser, m.tlTemp) && Toujours conserver cette instruction !

	ENDPROC

	* ------------------------------------------------------------
	PROTECTED FUNCTION wUserGet && Donne  FoxInCloud l'identifiant de l'utilisateur courant
		LPARAMETERS tlTemp && [.F.] Cet identifiant est emprunt (voir awServer.wlUserTemp)

		*!*	#IF .F. && DEBUT D'EXEMPLE DE CODE

		*!*		RETURN _Screen.myUserID

		*!*	#ELSE
		*!*
		*!*		RETURN DoDefault(m.tlTemp) && Supprimer cette instruction si vous implmentez

		*!*	#ENDIF  && FIN D'EXEMPLE DE CODE
		RETURN _SCREEN._clepkUser
	ENDPROC

	* ------------------------------------------------------------
	FUNCTION wUserName && Nom d'un utilisateur d'aprs ID dans l'application
		LPARAMETERS ;
			twUser AS Variant; &&
		, tcEmail AS STRING; && [''] @

		*!*	return DoDefault(@m.twUser, @m.tcEmail)


		*!*	&& implmenter si ncessaire dans votre sous-classe atfProcess
		*!*	&& s'excute dans la session de donnes de l'application

		*!*	#if .F. &&

		*!*	local lcResult as String;
		*!*	, loRecno as abRecno of abData.prg;
		*!*	, lcError as String;

		*!*	loRecno = abRecno('database!Users', @m.lcError) && USEs 'Users' table if needed, saves and restores Recno() if already USEd

		*!*	if Vartype(m.loRecno) == 'O'

		*!*		lcResult = Trim(Lookup(users.Name, m.twUser, users.id, 'id'))
		*!*		tcEmail = Trim(users.Email)

		*!*	else

		*!*		lcResult = Transform(m.twUser) && return data of the expected Type

		*!*		this.SendErrorEmail([Could not access 'users' table], Textmerge([This error was encountered: <<m.lcError>>])) && warn app admin, don't bother user

		*!*	endif

		*!*	return m.lcResult
		*!*
		*!*	#endif
		RETURN lire_nom_userId(m.twUser)
	ENDPROC

	* ==============================================================
	* == 2 == 2 == 2 == 2 == 2 == 2 == 2 == 2 == 2 == 2 == 2 == 2 ==
	* ==============================================================

	&& HTML FIGURANT EN TTE ET EN PIED DE VOS FORMULAIRES MATRES
	&& -----------------------------------------------------------
	&& Les mthodes qui suivent vous permettent d'ajouter du HTML personnalis
	&& en tte et en pied des pages obtenues avec this.wFormStandardPage()

	* ------------------------------------------------------------
	PROTECTED FUNCTION wFormHTML_cHeader && En-tte du formulaire

		&& Implmenter pour ajouter du HTML avant vos formulaires

		RETURN DODEFAULT() + TEXTMERGE([<p class="FIC"><<this.oConfig.cAppName>></p>]) && return <le html que vous voulez afficher>

	ENDFUNC

	* ------------------------------------------------------------
	PROTECTED FUNCTION wFormHTML_cFooter && Pied du formulaire

		&& Implmenter pour ajouter du HTML aprs votre formulaire

		RETURN DODEFAULT() + TEXTMERGE([<p class="FIC"><<this.oConfig.cAppName>></p>]) && return <le html que vous voulez afficher>

	ENDFUNC

	* ------------------------------------------------------------
	PROTECTED FUNCTION wFormHTML_cSignature && Signature de l'diteur

		RETURN DODEFAULT('<span>myCompany</span>') && return <le html que vous voulez afficher>

	ENDFUNC

	* ==============================================================
	* == 3 == 3 == 3 == 3 == 3 == 3 == 3 == 3 == 3 == 3 == 3 == 3 ==
	* ==============================================================

	&& MTHODES DES FORMULAIRES PRINCIPAUX
	&& Pour afficher une page HTML contenant un formulaire principal (top level),
	&& ajoutez une mthode portant le nom du formulaire appellant this.wFormStandardPage() comme indiqu ci-dessous

	&& ------------------------------------------------------
	&& LES MTHODES QUI SUIVENT SONT JUSTE DES EXEMPLES
	&& Vous pouvez les supprimer ou les commenter aprs en avoir pris connaissance
	&& note : 'atf' est le code de votre application choisi comme extension (cf. atfServer.cScriptMapExts)
	&& ------------------------------------------------------

	* -------------------------------------------
	PROCEDURE INDEX && Page d'accueil de votre application Web

		&& URLs dans votre site de dveloppement :
		&& - court: http://localhost/atfTest/
		&& - long : http://localhost/atfTest/index.atf
		&& Pour que l'URL courte ci-dessus fonctionne, rglez 'index.atf' comme la page par dfaut de votre application Web
		&& Pour ce faire, suivez ces tapes (IIS 7+):
		&& - Ouvrez la console de gestion IIS (inetmgr)
		&& - Ouvrez le noeud du site web par dfaut
		&& - Naviguez jusqu' votre application ('atfTest' / 'atfProd')
		&& - Click droit sur le noeud de l'application > 'Explorer' : ceci ouvre une fentre de l'explorateur Windows:
		&& . Renommer le fichier 'index.atf' le cas chant
		&& - dans la console IIS, ouvrir 'Document par dfaut':
		&& . cliquer 'ajouter' dans la colonne de droite ou le menu contextuel
		&& . saisissez 'index.atf' et cliquez 'OK'

		RETURN THIS.wFormStandardPage('Index.scx') &&

		&& Remplacez 'sampleIndex.scx' par le formulaire que vous souhaitez prsenter dans votre page d'accueil
		&& En gnral il s'agit d'un formulaire d'identification ou d'un formulaire 'splash' comportant une image et/ou des boutons de lien direct
		&& Assurez-vous que ce formulaire a .wlAnonymousAllowed = .T.

		* EXTERNAL FORM sampleIndex.scx && aspire 'sampleIndex.scx' dans le projet de l'application Web

	ENDPROC

	* -------------------------------------------
	&& Exemple 1 : 'SampleForm1.scx' est instanci sans paramtre

	PROCEDURE SampleForm1 && test URL: http://localhost/atfTest/SampleForm1.atf

		RETURN THIS.wFormStandardPage('SampleForm1.scx')

		* EXTERNAL FORM SampleForm1.scx && aspire 'SampleForm1.scx' dans le projet de l'application Web

	ENDPROC

	* -------------------------------------------
	&& Exemple 2 : 'SampleForm2' est une classe dans une library dfinie par atfServer.?AppSets*

	PROCEDURE SampleForm2 && test URL: http://localhost/atfTest/SampleForm2.atf

		RETURN THIS.wFormStandardPage('SampleForm2')

	ENDPROC

	* -------------------------------------------
	&& Exemple 3 : FoxInCloud passe deux paramtres  la mthode Init() du formulaire

	PROCEDURE SampleForm3 && test URL: http://localhost/atfTest/SampleForm3.atf

		RETURN THIS.wFormStandardPage('SampleForm3.scx';
			, 1; && 1er paramtre pass  SampleForm3.Init()
		, .F.; && 2nd paramtre pass  SampleForm3.Init()
		)

		* EXTERNAL FORM SampleForm3.scx && aspire 'SampleForm3.scx' dans le projet de l'application Web

	ENDPROC

	* -------------------------------------------
	&& Exemple 4 : FoxInCloud passe  la mthode Init() du formulaire deux paramtres communiqus dans la question de l'URL

	PROCEDURE SampleForm4 && test URL: http://localhost/atfTest/SampleForm4.atf?parm1=test&parm2=1

		RETURN THIS.wFormStandardPage('SampleForm4.scx';
			, REQUEST.QueryString('parm1'); && 1er paramtre pass  SampleForm4.Init()
		, INT(VAL(REQUEST.QueryString('parm2'))); && 2nd paramtre (entirer) pass  SampleForm4.Init()
		)

		* EXTERNAL FORM SampleForm4.scx && aspire 'SampleForm4.scx' dans le projet de l'application Web

	ENDPROC

	* -------------------------------------------
	&& Exemple 5 : identification avec le compte de la session prcdente pour le mme utilisateur

	PROCEDURE SampleForm5 && test URL: http://localhost/atfTest/SampleForm5.atf?parm1=test&parm2=1

		LOCAL laSession[1]

		SELECT TOP 1 USERID, LASTON;
			FROM wwSession;
			WHERE .T.;
			AND SessionID = m.Session.oData.SessionID;
			AND FIRSTON < m.Session.oData.FIRSTON;
			AND !EMPTY(USERID);
			ORDER BY LASTON DESC;
			INTO ARRAY laSession

		RETURN THIS.wFormStandardPage('SampleForm5.scx';
			, IIF(_TALLY = 1, laSession[1], .NULL.); && 1er paramtre pass  SampleForm5.Init()
		)

		#IF .F. && exemple de code pour votre form.init()
	PROCEDURE SampleForm5.INIT
		LPARAMETERS USERID
		IF PCOUNT() > 0
			DODEFAULT()
			IF SEEK(CAST(m.userID AS I), 'userTable', 'userID') && hypothse: userTable.userID est un entier
				THIS.txtLogin.VALUE = TRIM(userTable.login) && hypothse: votre textbox d'identifiant de connexion s'appelle 'txtLogin'
				THIS.txtPassWord.VALUE = TRIM(userTable.PASSWORD) && hypothse: votre textbox de mot de passe de connexion s'appelle 'txtPassWord'
				&& more code ...
			ENDIF
		ENDIF
	#ENDIF

ENDPROC

* ==============================================================
* == 4 == 4 == 4 == 4 == 4 == 4 == 4 == 4 == 4 == 4 == 4 == 4 ==
* ==============================================================

&& MTHODES AVANCEES

* -------------------------------------------
	PROCEDURE process_ante
		&& juste avant que le Serveur d'Application FoxInCloud n'excute une requte
		&& this.oServer, this.oRequest et this.oResponse sont disponible

		* -------------------------------------------
	PROCEDURE process_post
		&& juste aprs que le Serveur d'Application FoxInCloud a excut une requte
		&& this.oServer, this.oRequest et this.oResponse sont disponible
		&& /!\ this.oResponse est dj rempli

		* ==============================================================
		* == 5 == 5 == 5 == 5 == 5 == 5 == 5 == 5 == 5 == 5 == 5 == 5 ==
		* ==============================================================


		&& OPTIMISATION
		&& Mthodes que vous pouvez implmenter pour optimiser le temps de rponse de votre Serveur d'Application FoxInCloud

		* ------------------------------------------------------------
	PROTECTED PROCEDURE lAppUserEnvSave && save / restore application environment for this user
		LPARAMETERS ;
			tcMethod; && method of this object to execute (as lower case)
		, tcUserID && FiC user ID (= cookie / session ID)


		#IF .F. &&
			RETURN .F. &&
			RETURN NOT INLIST(m.tcMethod, LOWER('myMethod1'), LOWER('myMethod2'), LOWER('myMethod3')) &&
		#ENDIF


		&& RETURN .T. pour sauver l'environnement, sinon .F.
		&& (implmenter en sous-classe pour optimiser votre application)
		&& si votre application n'utilise aucun lment global dpendant de l'utilisateur :
		&& - aucun menu(s)
		&& - aucune barre(s) d'outils
		&& - aucune variable PUBLIC, _Screen.proprit ou _VFP.proprit o votre application stocke des informations dpendantes des actions de l'utilisateur
		&& ou vous stockez dans des variable PUBLIC, _Screen.proprit ou _VFP.proprit des donnes dfinies une fois pour toutes au lancement de l'application, jamais modifies par les actions de l'utilisateur,
		&& vous pouvez faire RETURN .F., ou, encore plus simple, rgler atfServer.lAppUserEnvSave = .F.

		#IF .F. && exemple d'implementation
			RETURN .F. && mon application n'a ni menu, ni variable PUBLIC relative  l'utilisateur, aucune _Screen.property et/ou _VFP.property relative  l'utilisateur, inutile de sauver / restaurer l'environnement de l'application
			RETURN NOT INLIST(m.tcMethod, LOWER('maMethode1'), LOWER('maMethode2'), LOWER('maMethode3')) && maMethode1, maMethode2 et maMethode3 sont extrieures  l'application Web, inutile de sauver / restaurer l'environnement de l'application
		#ENDIF

	ENDPROC

	* ===========================================
ENDDEFINE && CLASS atfProcess
* ===========================================
