*--------------------------------------------------------------------------------------------------------
* BasicSubClass
* Par Francis FAURE
*--------------------------------------------------------------------------------------------------------
* But : Crer une bibliothque VCX contenant une surcharge "vide" des classes visuelles de base de VFP
*--------------------------------------------------------------------------------------------------------


* test : Crer un MesClasses.VCX contenant une surcharge des classes visuelles VFP de base

 =CreateBasicSubClass("C:\GLS\GWSAV\PROGS\LIBS\gwSAV.vcx", "My_")

Return



Procedure CreateBasicSubClass(lsDir_File_VCX As String, lsPrefix As String, llEcraserSiExiste as Boolean)
LOCAL lobj as Object
If Type("m.lsDir_File_VCX")<>"C" OR Empty(m.lsDir_File_VCX)
  lsDir_File_VCX = "MyClass.vcx"
Else
  m.lsDir_File_VCX = Alltrim(m.lsDir_File_VCX)
Endif
If Type("m.lsPrefix")<>"C" or Empty(m.lsPrefix)
  lsPrefix = "u_"
Else
  m.lsPrefix = Alltrim(m.lsPrefix)
Endif
* Que faire en cas d'existence du VCX demand ?
If File(m.lsDir_File_VCX)
  IF m.llEcraserSiExiste
    CLEAR CLASSLIB (m.lsDir_File_VCX)
    ERASE (m.lsDir_File_VCX)
  else
    =Messagebox("La bibliothque VCX : " + m.lsDir_File_VCX + " Existe dj !" + Chr(13)+Chr(10) + "Opration Annule.")
    Return .F.
  endif
Endif

*  Ajout des classes visuelles
* (bizarrement dans l'ordre inverse de l'affichage dans le form designer...)
CREATE CLASSLIB (m.lsDir_File_VCX)

lobj=Createobject("Form")
  * --- personnalisations Form ---
  lobj.width=800
  lobj.height=600
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Form")

lobj=Createobject("Container")
  * --- personnalisations Container ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Container")

lobj=Createobject("Shape")
  * --- personnalisations Shape ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Shape")

lobj=Createobject("Line")
  * --- personnalisations Line ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Line")

lobj=Createobject("PageFrame")
  * --- personnalisations PageFrame ---
  lobj.PageCount=2
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"PageFrame")

lobj=Createobject("Timer")
  * --- personnalisations Timer ---
  lobj.width=24
  lobj.height=24
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Timer")

lobj=Createobject("Image")
  * --- personnalisations Image ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Image")

lobj=Createobject("Grid")
  * --- personnalisations Grid ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Grid")

lobj=Createobject("Spinner")
  * --- personnalisations Spinner ---
  lobj.height=27
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Spinner")

lobj=Createobject("ListBox")
  * --- personnalisations ListBox ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"ListBox")

lobj=Createobject("CheckBox")
  * --- personnalisations CheckBox ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"CheckBox")

lobj=Createobject("OptionGroup")
  * --- personnalisations OptionGroup ---
  lobj.ButtonCount=2
  lobj.width=100
  lobj.height=50
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"OptionGroup")

lobj=Createobject("CommandButton")
  * --- personnalisations ComandButton ---
  lobj.height=27
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"CommandButton")

*LOCAL  lobj as CommandGroup
lobj=Createobject("CommandGroup")
  * --- personnalisations CommandGroup ---
  lobj.width=110
  lobj.height=70
  lobj.MemberClass = m.lsPrefix+"CommandButton"
  lobj.MemberClassLibrary = m.lsDir_File_VCX
  lobj.ButtonCount=2
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"CommandGroup")

lobj=Createobject("Editbox")
  * --- personnalisations EditBox ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"EditBox")

lobj=Createobject("Textbox")
  * --- personnalisations TextBox ---
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"TextBox")

lobj=Createobject("Label")
  * --- personnalisations Label ---
  lobj.AutoSize = .T.
  lobj.BackStyle = 0
lobj.SaveAsClass(m.lsDir_File_VCX, m.lsPrefix+"Label")

Endproc


