
&& Constructeur de projet d'Application FoxInCloud
&& Ce programme vous explique comment crer le projet grce auquel vous compilerez votre serveur COM.
&& L'Assistant d'Adaptation FoxInCloud excute ce programme  la fin du processus de Publication.
&& Vous pouvez l'excuter  tout moment depuis l'environnement de dveloppement FoxInCloud

#DEFINE CRLF Chr(13)+Chr(10)
#DEFINE CRLF2 CRLF+CRLF

LPARAMETERS ;
  taFolder; && @ Sous-dossiers de l'application contenant du code (excution par l'Assistant d'Adaptation)
, tcResult; && @ Rsultat (cumulatif)
, tlResult; && @ Rsultat pour excution par DO

tcResult = Evl(m.tcResult, '')

LOCAL junk;
, lcResult;
, lcDosAB, lcDosAT;
, llFAA, llTrial, lcSys16, lcPJX, lcStem, lcDir, lcPRG, lcXXX;
, loPath AS abPathAddSubFolders OF ab.prg;
, loPJmgr AS abProject OF abDev.prg;
, loProject AS Project;

lcResult = ''

llFAA = Type('taFolder', 1) == 'A' && FAA a lanc ce programme
lcDosAB = Home(1) + 'Tools\AB\' && pas DOS_AB car on ne sait pas si *.h sont dans Set('Path') au moment de la compilation de ce programme
tlResult = Directory(m.lcDosAB) AND File(m.lcDosAB + 'ab.prg')
IF m.tlResult
	
	AB() && rgle cLangUser() mais pas Set('Path')

	* Si FoxInCloud est bien install
	tlResult = wlFoxInCloud(@m.llTrial)
	IF m.tlResult

		* Si le programme principal existe
		lcSys16 = Sys(16) && 
		lcStem = JustStem(cModuleInfo(m.lcSys16, 'Address', .T.)) && 
		lcDir = cModuleInfo(m.lcSys16, 'Path', .T.) && 
		lcPJX = ForcePath(m.lcStem, m.lcDir) && 
		lcPRG = ForceExt(m.lcPJX, 'prg') && Programme principal
		lcXXX = Left(m.lcPRG, 3)
		tlResult = File(m.lcPRG)
		IF m.tlResult

			* Si le projet peut tre ouvert ou cr
			loPJmgr = CreateObject('abProject', m.lcPJX, @m.lcResult)
			tlResult = Vartype(m.loPJmgr) == 'O'
			IF m.tlResult
				loProject = m.loPJmgr.oProject

				PathAdd(m.lcDosAB)
				PathAdd(m.lcDosAB + '\Graphics')
				oProjectFile(; && voir plus loin
						m.lcDosAB + 'ab.prg';
					,	ICase(;
							cLangUser() = 'fr',	[Couche publique de FoxInCloud ; https://github.com/FoxInCloud/FoxInCloud-AB],; && Copy-paste this line to add another language support
																	[FoxInCloud Public layer; https://github.com/FoxInCloud/FoxInCloud-AB]; && Default: English
						);
					)

				PathAdd(m.lcDosAB + 'AC\')
				oProjectFile(; && voir plus loin
						m.lcDosAB + 'AC\ac.prg';
					,	ICase(;
							cLangUser() = 'fr',	[Couche prive de FoxInCloud],; && Copy-paste this line to add another language support
																	[FoxInCloud Private layer]; && Default: English
						);
					)

				PathAdd(m.lcDosAB + 'AW\')
				oProjectFile(; && voir plus loin
						m.lcDosAB + 'AW\aw.prg';
					,	ICase(;
							cLangUser() = 'fr',	[Couche Web de FoxInCloud],; && Copy-paste this line to add another language support
																	[FoxInCloud Web layer]; && Default: English
						);
					)

				PathAdd(m.lcDosAB + 'WC\Classes')
				oProjectFile(; && voir plus loin
						m.lcDosAB + 'WC\Classes\wConnect.prg';
					,	ICase(;
							cLangUser() = 'fr',	[Charge West-Wind Web Connect],; && Copy-paste this line to add another language support
																	[West-Wind Web Connect loader]; && Default: English
						);
					)


				* Ajouter les dossiers du projet  Set('Path')
				PathAdd(m.lcDir)
				loPath = Iif(m.llFAA;
					, CreateObject('abPathesAdd', @m.taFolder); && Ajoute les sous-dossiers passs  Set('PATH')
					, CreateObject('abPathAddSubFolders', m.lcDir, 3); && Ajoute arbitrairement 3 niveaux de sous-dossiers  Set('PATH')
					)


				oProjectFile(; && voir plus loin
						m.lcPRG;
					,	ICase(;
							cLangUser() = 'fr',	[Programme principal du Serveur d'Application FoxInCloud],; && Copy-paste this line to add another language support
																	[FoxInCloud Application Server main program]; && Default: English
						);
					)

				loProject.SetMain(m.lcPRG)
				

				* ==================================
				* Si le projet peut tre (re)construit
				= MessageBox(Textmerge(ICase(;
						cLangUser() = 'fr',	[Le projet '<<m.lcPJX>>' va maintenant tre contruit...] + CRLF2 + [Si le gestionnaire de projet vous demande de trouver un fichier cliquez] + CRLF+ ['Ignorer tout'] + CRLF2 + [Les rfrences manquantes seront trouves ultrieurement.],; && Copy-paste this line to add another language support
																[Project '<<m.lcPJX>>' will now be built...] + CRLF2 + [If project manager asks you to locate a file, just click] + CRLF+ ['Ignore all'] + CRLF2 + [Missing references will be found later.]; && Default: English
						));
					, 0, 'FoxInCloud Project Builder', 4*10^3)
				
				IgnoreAll() && modify command abDev
				tlResult = m.loProject.Build(; && ajoute les dpendances automatiquement
						m.lcPJX;
					, 1; && 1: Rebuild
					, .F.; && 
					, .F.; && {FiC V 2.25.0-beta.9} 
					)
				keyboard '' clear

				IF m.tlResult

					* Peaufiner le projet
					WITH m.loProject AS Project
						.Icon = Evl(.Icon, m.lcDosAB + 'Graphics\aw.ico') && 
						.VersionCopyright = Evl(.VersionCopyright, 'FoxInCloud')
						.VersionDescription = Evl(.VersionDescription, 'FoxInCloud Application Server')
						.VersionLanguage = Evl(.VersionLanguage, Sys(3004)) && 
						.VersionTrademarks = Evl(.VersionTrademarks, 'FoxInCloud, West-Wind wConnect, ActiveWidgets')
						.VersionNumber = Iif(Empty(Val(.VersionNumber)), '1.0.0', .VersionNumber)
						.AutoIncrement = .T.
					ENDWITH

					* Ajouter le fichier ini du serveur
					oProjectFile(; && voir plus loin
							ForceExt(m.lcPRG, 'ini');
						,	ICase(;
								cLangUser() = 'fr',	[Paramtres du serveur d'Application FoxInCloud ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																		[FoxInCloud Application Server parameters; keep EXCLUDED from project]; && Default: English
							);
						,	.T.;
						,	'T'; && 'X' by default
						)

					* Ajouter le config.fpw FoxInCloud
					oProjectFile(; && voir plus loin
							m.lcDosAB + 'AW\config.fpw';
						,	ICase(;
								cLangUser() = 'fr',	[Configuration VFP pour le serveur d'Application FoxInCloud ; garder INCLUS dans le projet],; && Copy-paste this line to add another language support
																		[VFP configuration for FoxInCloud Application Server; always keep INCLUDED in project]; && Default: English
							);
						,	.F.;
						,	'T'; && 'X' by default
						)

					* ce prg
					oProjectFile(; && voir plus loin
							m.lcSys16;
						,	ICase(;
								cLangUser() = 'fr',	[Reconstruit ce projet ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																		[Rebuilds this project; keep EXCLUDED from project]; && Default: English
							);
							,	.T.; && 
						)

					* gnration des CSS
					oProjectFile(; && voir plus loin
							ForceExt(m.lcStem, 'css.prg'); && ForcePath(ForceExt(m.lcStem, 'css') + '.prg', m.lcDir) && 2016-04-04 thn -- {FiC V 2.21.0} store all programs in subfolder
						,	ICase(;
								cLangUser() = 'fr',	[Gnre la CSS de l'application ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																		[Generates Application CSS; keep EXCLUDED from project]; && Default: English
							);
							,	.T.; && 
						)


					* =======================
					* Si version Full
					* =======================
					lcDosAT = m.lcDosAB + 'AT\'
					IF Directory(m.lcDosAT)
					
						* mise  jour du serveur de production
						oProjectFile(; && voir plus loin
								ForceExt(m.lcStem, 'update.prg'); && ForcePath(ForceExt(m.lcStem, 'update') + '.prg', m.lcDir) && 2016-04-04 thn -- {FiC V 2.21.0} store all programs in subfolder
							,	ICase(;
									cLangUser() = 'fr',	[Met  jour atfTest.exe sur votre serveur de production en mode COM ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																			[Builds atfTest.exe and updates your COM mode production server; keep EXCLUDED from project]; && Default: English
								);
								,	.T.; && 
							)

						* download table d'tat pour un user
						oProjectFile(; && voir plus loin
								ForceExt(m.lcStem, 'UserPropsTableGet.prg');
							,	ICase(;
									cLangUser() = 'fr',	[Tlcharge du serveur de production une table d'tat pour un formulaire et un utilisateur ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																			[Downloads from production server a form state table for a given user; keep EXCLUDED from project]; && Default: English
								);
								,	.T.; && 
							)

						oProjectFile(; && voir plus loin
								ForceExt(m.lcStem, 'SessionGet.prg');
							,	ICase(;
									cLangUser() = 'fr',	[Fusionne la table de sessions du serveur de production avec la table locale ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																			[Merges session table from production server with local session table; keep EXCLUDED from project]; && Default: English
								);
								,	.T.; && 
							)

						oProjectFile(; && voir plus loin
								ForceExt(m.lcStem, 'RequestLogGet.prg');
							,	ICase(;
									cLangUser() = 'fr',	[Fusionne la table de log du serveur de production avec le log local ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																			[Merges log table from production server with local log; keep EXCLUDED from project]; && Default: English
								);
								,	.T.; && 
							)

						oProjectFile(; && voir plus loin
								m.lcDosAT + 'atPJclean.prg';
							,	ICase(;
									cLangUser() = 'fr',	[Supprime les rfrences de fichiers obsoltes et compacte le projet ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																			[Remove dead file references from, and packs active project; keep EXCLUDED from project]; && Default: English
								);
							,	.T.; && 
							)

						oProjectFile(; && voir plus loin
								m.lcDosAT + 'atPJcompile.prg';
							,	ICase(;
									cLangUser() = 'fr',	[Compile tous les fichiers sources du projet ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																			[Compile all source files in project; keep EXCLUDED from project]; && Default: English
								);
							,	.T.; && 
							)
						
						oProjectFile(; && voir plus loin
								m.lcDosAT + 'atPJcompileDebugMode.prg';
							,	ICase(;
									cLangUser() = 'fr',	[Compile le projet alternativement en mode debug et production ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																			[Toggles/compiles project between debug and production modes; keep EXCLUDED from project]; && Default: English
								);
							,	.T.; && 
							)

						oProjectFile(; && voir plus loin
								m.lcDosAT + 'atTempClear.prg';
							,	ICase(;
									cLangUser() = 'fr',	[Vide le dossier temporaire du serveur FoxInCloud ; garder EXCLUS du projet],; && Copy-paste this line to add another language support
																			[Empties FoxInCloud Server's Temp folder; keep EXCLUDED from project]; && Default: English
								);
							,	.T.; && 
							)
						ENDIF
							
						&& Ajouter les fichiers.h au projet
				ELSE
					lcResult = Textmerge(ICase(;
						cLangUser() = 'fr',	[Le Projet '<<m.lcPJX>>' ne peut tre (re)construit],; && Copy-paste this line to add another language support
																[Project '<<m.lcPJX>>' could not be (re)built properly]; && Default: English
					))
				ENDIF
			ELSE
				lcResult = c2Words(Textmerge(ICase(;
							cLangUser() = 'fr',	[Le projet '<<m.lcPJX>>' ne peut tre ouvert ou cr],; && Copy-paste this line to add another language support
																	[Project '<<m.lcPJX>>' can't be opened or created]; && Default: English
						)), ': ', m.lcResult)
			ENDIF
		ELSE
			lcResult = Textmerge(ICase(;
				cLangUser() = 'fr',	[Le programme principal '<<m.lcPRG>>' est introuvable],; && Copy-paste this line to add another language support
														[Main program '<<m.lcPRG>>' can't be found]; && Default: English
			))
		ENDIF
	ELSE
		lcResult = Textmerge(ICase(;
			cLangUser() = 'fr',	[Le FoxInCloud Web Application Studio est mal install.] + CRLF2 + [Veuillez vrifier votre installation FoxInCloud.],; && Copy-paste this line to add another language support
													[FoxInCloud Web Application Studio is not properly installed] + CRLF2 + [Please check your FoxInCloud installation.]; && Default: English
		))
	ENDIF
	
	tcResult = c2Words(m.tcResult, CRLF, m.lcResult)

ELSE
	lcResult = Textmerge([Folder '<<m.lcDosAB>>' (Home(1) + 'Tools\AB\') can't be found...] + CRLF2 + [please check your VFP and FoxInCloud installation])
	&& ce cas ne peut jamais survenir avec FAA car il a tout vrifi en amont ...
ENDIF

IF NOT (m.tlResult OR m.llFAA)
	MessageBox(Textmerge([<<m.lcResult>> ... ] + CRLF2 + ICase(;
		cLangUser() = 'fr',	[Construction du projet avorte.],; && Copy-paste this line to add another language support
												[Project build aborted.]; && Default: English
		)), 16, 'FoxInCloud Project Builder')
ENDIF

RETURN m.tlResult

* ------------------------------------------------
FUNCTION oProjectFile AS File
LPARAMETERS ;
	tcFile,; && File
	tcDesc,; && Description
	tlExclude,; && [.F.] 
	tcType && [Type based on extension] Type for project manager

LOCAL loResult AS File
loResult = .NULL.

IF lFile(m.tcFile)

	loResult = Iif(Type('_VFP.ActiveProject.Files(m.tcFile)') == 'O';
		, _VFP.ActiveProject.Files(m.tcFile);
		, _VFP.ActiveProject.Files.Add(m.tcFile);
		)
	IF Vartype(m.loResult) == 'O'

		loResult.Description = Evl(m.tcDesc, loResult.Description)
		loResult.Exclude = lTrue(m.tlExclude)
		loResult.Type = Evl(m.tcType, m.loResult.Type)
	ENDIF
ENDIF

return m.loResult
endfunc
