(function(){
	var dStart = new Date();
	var grd = $('sav_scx-cntarticle-grdarticle');
	if (grd){
		Object.extend(grd, {oGrid: new AW.UI.Grid, oTable: new AW.XML.Table});
		var oGrid  = grd.oGrid, oTable = grd.oTable, oTempl;
		oGrid.defineCellProperty('CurrentControl', null);
		oGrid.defineControlProperty('DataUpdate', false);
		oGrid.setTabIndex("8");
		oGrid.setSelectorWidth(10);
		oGrid.getSelectorTemplate().setStyle('font-weight','bold');
		oGrid.setRowCount(0);
		oGrid.setCurrentColumn(-1);
		oGrid.setCurrentRow(-1);
		oGrid.setCellSelected(false, oGrid.getCurrentColumn(), oGrid.getCurrentRow());
		oGrid.setSelectionMode('single-row');
		oGrid.setSelectedRows([-1]);
		oGrid.setSelectedRows([parseInt(oGrid.getCurrentRow(), 10)]);
		oGrid.setStyle('background-color','#F5F5F5');
		oGrid.clearColumnModel();
		oGrid.setColumnCount(4);
		oGrid.setStyle('font-family','Arial');
		oGrid.setStyle('font-size','12pt');
		oGrid.setStyle('color','#646464');
		oGrid.setHeaderHeight(25);
		oGrid.setSize(undefined,210);
		oGrid.setRowHeight(31);
		oGrid.setScrollBars('vertical');
		oGrid.defineControlProperty('Statusbartext');
		oGrid.setControlStatusbartext('');
		oGrid.setSize(830,undefined);
		oGrid.setColumnIndices([0,1,2,3]);
		oGrid.setCellEditable(false,0);
		oGrid.setColumnResizable(true,0);
		oGrid.setColumnWidth(160+1,0);
		oGrid.setCellEditable(false,1);
		oGrid.setColumnResizable(true,1);
		oGrid.setColumnWidth(380+1,1);
		oGrid.setCellEditable(false,2);
		oGrid.setColumnResizable(true,2);
		oGrid.setColumnWidth(160+1,2);
		oGrid.setCellEditable(false,3);
		oGrid.setColumnResizable(true,3);
		
		
		/* Column 0 'Column1' */
		oTempl = oGrid.getHeaderTemplate(0);
		oTempl.setStyle('text-align','center');
		oTempl.setStyle('font-weight','bold');
		oGrid.setCellTemplate('',0,undefined);
		oGrid.setCellCurrentControl('text1', 0);
		oTempl = oGrid.getCellTemplate(0);
		oTempl.setStyle('text-align','left');
		var f1 = function(row,val){return this.getCellTemplate(0,row).setStyle('text-decoration',val);}.bind(oGrid);
		
		/* Column 1 'Column2' */
		oTempl = oGrid.getHeaderTemplate(1);
		oTempl.setStyle('text-align','center');
		oTempl.setStyle('font-weight','bold');
		oGrid.setCellTemplate('',1,undefined);
		oGrid.setCellCurrentControl('text1', 1);
		oTempl = oGrid.getCellTemplate(1);
		oTempl.setStyle('text-align','left');
		var f2 = function(row,val){return this.getCellTemplate(1,row).setStyle('text-decoration',val);}.bind(oGrid);
		
		/* Column 2 'Column3' */
		oTempl = oGrid.getHeaderTemplate(2);
		oTempl.setStyle('text-align','center');
		oTempl.setStyle('font-weight','bold');
		oGrid.setCellTemplate('',2,undefined);
		oGrid.setCellCurrentControl('text1', 2);
		oTempl = oGrid.getCellTemplate(2);
		oTempl.setStyle('text-align','left');
		var f3 = function(row,val){return this.getCellTemplate(2,row).setStyle('text-decoration',val);}.bind(oGrid);
		
		/* Column 3 'Column4' */
		oTempl = oGrid.getHeaderTemplate(3);
		oTempl.setStyle('text-align','center');
		oTempl.setStyle('font-weight','bold');
		oGrid.setCellTemplate('',3,undefined);
		var fmt = new AW.Formats.Number;
		fmt.setTextFormat('###');
		oGrid.setCellFormat(fmt,3,undefined);
		oGrid.setCellCurrentControl('text1', 3);
		oTempl = oGrid.getCellTemplate(3);
		oTempl.setStyle('text-align','right');
		var f4 = function(row,val){return this.getCellTemplate(3,row).setStyle('text-decoration',val);}.bind(oGrid);
		
		oGrid.setHeaderText('NATURE-TYPE', 0);
		oGrid.setCellEditable(true,0);
		oGrid.setCellEditable(false,0);
		oGrid.setHeaderText('ARTICLE', 1);
		oGrid.setCellEditable(true,1);
		oGrid.setCellEditable(false,1);
		oGrid.setHeaderText('REFERENCE', 2);
		oGrid.setCellEditable(true,2);
		oGrid.setCellEditable(false,2);
		oGrid.setHeaderText('COUT', 3);
		oGrid.setCellEditable(true,3);
		oGrid.setCellEditable(false,3);
		oGrid.setSortDirection();
		oGrid.refresh();
		oGrid.defineRowProperty('tuRow', null);
		oGrid.defineRowProperty('Clicked', false);
		if (FoxInCloud.gridRowChangeDelay > 0){
			oGrid.onRowMouseDown = function(event, row){this.setRowClicked(true, row)};
			oGrid.onRowMouseUp = function(event, row){this.setRowClicked(false, row)};
		}
		oGrid.onCurrentRowChanged = function(row){
			var value = this.getRowProperty('tuRow', row);
			if (!(this.disabled || value === null)){
				var rowClicked = this.getRowClicked(row);
				if (FoxInCloud.gridRowChangeDelay > 0 && (!rowClicked || FoxInCloud.gridRowChangeDelayClicked > 0)){
					if (this.nTOrow) window.clearTimeout(this.nTOrow);
					this.nTOrow = FoxInCloud.gridMethod.bind(FoxInCloud).delay(FoxInCloud[rowClicked ? 'gridRowChangeDelayClicked' : 'gridRowChangeDelay'], 'wAfterRowChange', $('sav_scx-cntarticle-grdarticle'), value);
				}
				else FoxInCloud.gridMethod('wAfterRowChange', $('sav_scx-cntarticle-grdarticle'), value);
			}
		};
		
		
		oGrid.onCellValidating = function(text, col, row){
			var result, dynCC, template, fmt, value, done;
			col = parseInt(col, 10);
			if (typeof row === 'undefined') {
				template = this.getCellTemplate(col);
				dynCC = this.getCellCurrentControl(col);
			}
			else {
				row = parseInt(row, 10);
				dynCC = this.getCellCurrentControl(col,row);
				template = this.getCellTemplate(col,row);
			}
			if (template.disabled) return;
			if (template.readOnly) return;
			if (typeof text === 'string'){
				fmt = this.getCellFormat(col, row);
				value = fmt ? fmt.textToValue(text) : text;
			}
			switch (col){
				case 0: if(dynCC === 'text1'){result = FoxInCloud.gridEditEvent('blur', $('sav_scx-cntarticle-grdarticle'), value, 'sav_scx-cntarticle-grdarticle-column1-text1', true); done=!result; break;}
				case 1: if(dynCC === 'text1'){result = FoxInCloud.gridEditEvent('blur', $('sav_scx-cntarticle-grdarticle'), value, 'sav_scx-cntarticle-grdarticle-column2-text1', true); done=!result; break;}
				case 2: if(dynCC === 'text1'){result = FoxInCloud.gridEditEvent('blur', $('sav_scx-cntarticle-grdarticle'), value, 'sav_scx-cntarticle-grdarticle-column3-text1', true); done=!result; break;}
				case 3: if(dynCC === 'text1'){result = FoxInCloud.gridEditEvent('blur', $('sav_scx-cntarticle-grdarticle'), value, 'sav_scx-cntarticle-grdarticle-column4-text1', true); done=!result; break;}
			}
			if (done){
				var cols = this.getColumnCount(), rows = this.getRowCount(), done = false, row_ = row;
				col++;
				while (row < rows && !done) {
					if (this.getCellEditable(col,row)) {
						this.setSelectedColumns([col]);
						this.setCurrentColumn(col);
						if (row !== row_){
							this.setSelectedRows([row]);
							this.setCurrentRow(row);
						}
						done = true;
					}
					else {
						col++;
						if (col >= cols){
							col = 0;
							row++;
						}
					}
				}
			}
			return result;
		};
		
		oGrid.onKeyBackspace = function(event){
			Event.extend(event).stop();
		};
		
		oGrid.setSelectedRows([-1]);
		oGrid.setSelectedRows([-1]);
		oGrid.disabled = true;
		oGrid.setCurrentRow(-1);
		oGrid.disabled = false;
		grd.update(oGrid);
	}
	dStart = new Date() - dStart;
	window.console && console.log && console.log("'sav_scx-cntarticle-grdarticle' grid script took 109 ms. to generate on the server, " + dStart + " ms to execute on the browser, total " + (dStart + 109) + " ms.\n" + 'awhtml.fxp!Ogrdarticle.gethtml_grd_aw_cscript_() - state changes > JavaScript: 62 ms.\nawhtml.fxp!Ogrdarticle.gethtml_grd_aw_cxml_() - current state XML 15 ms.\nawhtml.fxp!Ogrdarticle.gethtml_grd_aw_cxml_rs_calias() - .RecordSource "v_articlereparation" > RecordSet using Select-SQL: 15 ms.\nawhtml.fxp!Ogrdarticle.gethtml_grd_aw_cxml_rs_calias() - Current record located using unique key expression "v_articlereparation.clepk" = .F.: 0 ms.\nawhtml.fxp!Ogrdarticle.gethtml_grd_aw_cxml_rs() - \'v_articlereparation\' RecordSet > XML (0 rows): 0 ms.\nawhtml.fxp!Ogrdarticle.gethtml_grd_aw_cscript_oxmlchanges() - state changes: 16 ms.\nawhtml.fxp!Ogrdarticle.gethtml_grd_aw_cscript_rs() - data changes > JS: 0 ms.\nawhtml.fxp!Ogrdarticle.gethtml_grd_aw_cscript_events() - event handlers: 31 ms.');
})();
